searchNodes=[{"ref":"Elsa.html","title":"Elsa","type":"module","doc":"Provides public api to Elsa. Top-level short-cuts to sub-module functions for performing basic interactions with Kafka including listing, creating, deleting, and validating topics. Also provides a function for one-off produce_sync of message(s) to a topic."},{"ref":"Elsa.html#create_topic/3","title":"Elsa.create_topic/3","type":"function","doc":"See Elsa.Topic.create/3."},{"ref":"Elsa.html#default_client/0","title":"Elsa.default_client/0","type":"function","doc":"Define a default client name for establishing persistent connections to the Kafka cluster by producers and consumers. Useful for optimizing interactions by passing the identifier of a standing connection instead of instantiating a new one at each interaction, but when only a single connection is required, aleviating the need for the caller to differentiate and pass around a name."},{"ref":"Elsa.html#delete_topic/2","title":"Elsa.delete_topic/2","type":"function","doc":"See Elsa.Topic.delete/2."},{"ref":"Elsa.html#fetch/3","title":"Elsa.fetch/3","type":"function","doc":"See Elsa.Fetch.fetch/3."},{"ref":"Elsa.html#list_topics/1","title":"Elsa.list_topics/1","type":"function","doc":"See Elsa.Topic.list/1."},{"ref":"Elsa.html#produce/4","title":"Elsa.produce/4","type":"function","doc":"See Elsa.Producer.produce/4."},{"ref":"Elsa.html#produce_sync/3","title":"Elsa.produce_sync/3","type":"function","doc":"See Elsa.Producer.produce_sync/3."},{"ref":"Elsa.html#topic?/2","title":"Elsa.topic?/2","type":"function","doc":"See Elsa.Topic.exists?/2."},{"ref":"Elsa.ConnectError.html","title":"Elsa.ConnectError","type":"exception","doc":""},{"ref":"Elsa.Consumer.MessageHandler.html","title":"Elsa.Consumer.MessageHandler","type":"behaviour","doc":"Define the behaviour and default implementations of functions for creating message handlers that will be called by Elsa worker processes."},{"ref":"Elsa.Consumer.MessageHandler.html#__using__/1","title":"Elsa.Consumer.MessageHandler.__using__/1","type":"macro","doc":"Defines the macro for implementing the message handler behaviour in an application. Default implementations allow injecting of configuration into the worker process, persisting state between runs of the message handler function, or alternatively, basic processing and acknowlegement of messages."},{"ref":"Elsa.Consumer.MessageHandler.html#c:handle_messages/1","title":"Elsa.Consumer.MessageHandler.handle_messages/1","type":"callback","doc":""},{"ref":"Elsa.Consumer.MessageHandler.html#c:handle_messages/2","title":"Elsa.Consumer.MessageHandler.handle_messages/2","type":"callback","doc":""},{"ref":"Elsa.Consumer.MessageHandler.html#c:init/1","title":"Elsa.Consumer.MessageHandler.init/1","type":"callback","doc":""},{"ref":"Elsa.Fetch.html","title":"Elsa.Fetch","type":"module","doc":"Provides functions for doing one-off retrieval of messages from the Kafka cluster."},{"ref":"Elsa.Fetch.html#fetch/3","title":"Elsa.Fetch.fetch/3","type":"function","doc":"A simple interface for quickly retrieving a message set from the cluster on the given topic. Partition and offset may be specified as keyword options, defaulting to 0 in both cases if either is not supplied by the caller."},{"ref":"Elsa.Fetch.html#fetch_stream/3","title":"Elsa.Fetch.fetch_stream/3","type":"function","doc":"Retrieves all messages on a given topic across all partitions by default. Evaluates lazily, returning a Stream resource containing the messages. By default the starting offset is the earliest message offset and fetching continues until the latest offset at the time the stream is instantiated. Refine the scope of stream fetch by passing the start_offset and end_offset keyword arguments."},{"ref":"Elsa.Fetch.html#search/4","title":"Elsa.Fetch.search/4","type":"function","doc":"Retrieves a stream of messages for which the supplied function evaluates to true. Search can be limited by an offset which is passed through to the underlying fetch_stream/3 call retrieving the messages to search. All options for fetch_stream/3 are respected."},{"ref":"Elsa.Fetch.html#search_keys/4","title":"Elsa.Fetch.search_keys/4","type":"function","doc":"Retrieves a stream of messages where the keys contains the supplied search string. Search can be further limited by an offset which is passed through to the underlying fetch_stream/3 call retrieving the messages to search. All options for fetch_stream/3 are respected."},{"ref":"Elsa.Fetch.html#search_values/4","title":"Elsa.Fetch.search_values/4","type":"function","doc":"Retrieves a stream of messages where the values contains the supplied search string. Search can be further limited by an offset which is passed through to the underlying fetch_stream/3 call retrieving the messages to search. All options for fetch_stream/3 are respected."},{"ref":"Elsa.Group.DirectAcknowledger.html","title":"Elsa.Group.DirectAcknowledger","type":"module","doc":""},{"ref":"Elsa.Group.DirectAcknowledger.html#ack/6","title":"Elsa.Group.DirectAcknowledger.ack/6","type":"function","doc":""},{"ref":"Elsa.Group.DirectAcknowledger.html#child_spec/1","title":"Elsa.Group.DirectAcknowledger.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Elsa.Group.DirectAcknowledger.html#handle_continue/2","title":"Elsa.Group.DirectAcknowledger.handle_continue/2","type":"function","doc":"Invoked to handle continue instructions. It is useful for performing work after initialization or for splitting the work in a callback in multiple steps, updating the process state along the way. Return values are the same as c:handle_cast/2. This callback is optional. If one is not implemented, the server will fail if a continue instruction is used. This callback is only supported on Erlang/OTP 21+. Callback implementation for GenServer.handle_continue/2."},{"ref":"Elsa.Group.DirectAcknowledger.html#init/1","title":"Elsa.Group.DirectAcknowledger.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Elsa.Group.DirectAcknowledger.html#start_link/1","title":"Elsa.Group.DirectAcknowledger.start_link/1","type":"function","doc":""},{"ref":"Elsa.Group.Manager.html","title":"Elsa.Group.Manager","type":"module","doc":"Defines the GenServer process that coordinates assignment of workers to topics/partitions of a given consumer group. Tracks consumer group state and reinstantiates workers to the last unacknowledged message in the event of failure."},{"ref":"Elsa.Group.Manager.html#ack/2","title":"Elsa.Group.Manager.ack/2","type":"function","doc":"Trigger acknowldgement of processed messages back to the cluster."},{"ref":"Elsa.Group.Manager.html#ack/5","title":"Elsa.Group.Manager.ack/5","type":"function","doc":"Trigger acknowledgement of processed messages back to the cluster."},{"ref":"Elsa.Group.Manager.html#assignments_received/4","title":"Elsa.Group.Manager.assignments_received/4","type":"function","doc":"Trigger the assignment of workers to a given topic and partition"},{"ref":"Elsa.Group.Manager.html#assignments_revoked/1","title":"Elsa.Group.Manager.assignments_revoked/1","type":"function","doc":"Trigger deallocation of all workers from the consumer group and stop worker processes."},{"ref":"Elsa.Group.Manager.html#brod_received_assignment/1","title":"Elsa.Group.Manager.brod_received_assignment/1","type":"macro","doc":""},{"ref":"Elsa.Group.Manager.html#brod_received_assignment/2","title":"Elsa.Group.Manager.brod_received_assignment/2","type":"macro","doc":""},{"ref":"Elsa.Group.Manager.html#child_spec/1","title":"Elsa.Group.Manager.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Elsa.Group.Manager.html#get_committed_offsets/2","title":"Elsa.Group.Manager.get_committed_offsets/2","type":"function","doc":"Callback implementation for c::brod_group_member.get_committed_offsets/2."},{"ref":"Elsa.Group.Manager.html#handle_continue/2","title":"Elsa.Group.Manager.handle_continue/2","type":"function","doc":"Invoked to handle continue instructions. It is useful for performing work after initialization or for splitting the work in a callback in multiple steps, updating the process state along the way. Return values are the same as c:handle_cast/2. This callback is optional. If one is not implemented, the server will fail if a continue instruction is used. This callback is only supported on Erlang/OTP 21+. Callback implementation for GenServer.handle_continue/2."},{"ref":"Elsa.Group.Manager.html#init/1","title":"Elsa.Group.Manager.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Elsa.Group.Manager.html#start_link/1","title":"Elsa.Group.Manager.start_link/1","type":"function","doc":"Start the group manager process and register a name with the process registry."},{"ref":"Elsa.Group.Manager.html#t:assignment_received_handler/0","title":"Elsa.Group.Manager.assignment_received_handler/0","type":"type","doc":"Function called for each new assignment"},{"ref":"Elsa.Group.Manager.html#t:assignments_revoked_handler/0","title":"Elsa.Group.Manager.assignments_revoked_handler/0","type":"type","doc":"Function called for when assignments have been revoked"},{"ref":"Elsa.Group.Manager.html#t:begin_offset/0","title":"Elsa.Group.Manager.begin_offset/0","type":"type","doc":"The offset from wthich to begin fetch requests: default = latest"},{"ref":"Elsa.Group.Manager.html#t:consumer_config/0","title":"Elsa.Group.Manager.consumer_config/0","type":"type","doc":"Values to configure the consumer, all are optional"},{"ref":"Elsa.Group.Manager.html#t:endpoints/0","title":"Elsa.Group.Manager.endpoints/0","type":"type","doc":"endpoints to connect to kafka brokers"},{"ref":"Elsa.Group.Manager.html#t:generation_id/0","title":"Elsa.Group.Manager.generation_id/0","type":"type","doc":""},{"ref":"Elsa.Group.Manager.html#t:group/0","title":"Elsa.Group.Manager.group/0","type":"type","doc":""},{"ref":"Elsa.Group.Manager.html#t:handler/0","title":"Elsa.Group.Manager.handler/0","type":"type","doc":"Module that implements the Elsa.Consumer.MessageHandler behaviour"},{"ref":"Elsa.Group.Manager.html#t:hostname/0","title":"Elsa.Group.Manager.hostname/0","type":"type","doc":""},{"ref":"Elsa.Group.Manager.html#t:max_bytes/0","title":"Elsa.Group.Manager.max_bytes/0","type":"type","doc":"Maximum bytes to fetch in batch of messages: default = 1MB"},{"ref":"Elsa.Group.Manager.html#t:max_wait_time/0","title":"Elsa.Group.Manager.max_wait_time/0","type":"type","doc":"Max number of milliseconds to wait to wait for broker to collect min_bytes of messages: default = 10_000 ms"},{"ref":"Elsa.Group.Manager.html#t:min_bytes/0","title":"Elsa.Group.Manager.min_bytes/0","type":"type","doc":"Minimum bytes to fetch in batch of messages: default = 0"},{"ref":"Elsa.Group.Manager.html#t:offset_reset_policy/0","title":"Elsa.Group.Manager.offset_reset_policy/0","type":"type","doc":"How to reset begin_offset if OffsetOutOfRange exception is received"},{"ref":"Elsa.Group.Manager.html#t:partition/0","title":"Elsa.Group.Manager.partition/0","type":"type","doc":""},{"ref":"Elsa.Group.Manager.html#t:portnum/0","title":"Elsa.Group.Manager.portnum/0","type":"type","doc":""},{"ref":"Elsa.Group.Manager.html#t:prefetch_bytes/0","title":"Elsa.Group.Manager.prefetch_bytes/0","type":"type","doc":"The total number of bytes allowed to fetch-ahead: default = 100KB"},{"ref":"Elsa.Group.Manager.html#t:prefetch_count/0","title":"Elsa.Group.Manager.prefetch_count/0","type":"type","doc":"The windows size (number of messages) allowed to fetch-ahead: default = 10"},{"ref":"Elsa.Group.Manager.html#t:sleep_timeout/0","title":"Elsa.Group.Manager.sleep_timeout/0","type":"type","doc":"Allow consumer process to sleep this amount of ms if kafka replied with &#39;empty&#39; messages: default = 1_000 ms"},{"ref":"Elsa.Group.Manager.html#t:start_config/0","title":"Elsa.Group.Manager.start_config/0","type":"type","doc":"keyword list of config values to start elsa consumer"},{"ref":"Elsa.Group.Manager.html#t:topic/0","title":"Elsa.Group.Manager.topic/0","type":"type","doc":""},{"ref":"Elsa.Group.Manager.State.html","title":"Elsa.Group.Manager.State","type":"module","doc":"The running state of the consumer group manager process."},{"ref":"Elsa.Group.Manager.WorkerManager.html","title":"Elsa.Group.Manager.WorkerManager","type":"module","doc":"Provides functions to encapsulate the management of worker processes by the consumer group manager."},{"ref":"Elsa.Group.Manager.WorkerManager.html#brod_received_assignment/1","title":"Elsa.Group.Manager.WorkerManager.brod_received_assignment/1","type":"macro","doc":""},{"ref":"Elsa.Group.Manager.WorkerManager.html#brod_received_assignment/2","title":"Elsa.Group.Manager.WorkerManager.brod_received_assignment/2","type":"macro","doc":""},{"ref":"Elsa.Group.Manager.WorkerManager.html#get_generation_id/3","title":"Elsa.Group.Manager.WorkerManager.get_generation_id/3","type":"function","doc":"Retrieve the generation id, used in tracking assignments of workers to topic/partition, from the worker state map."},{"ref":"Elsa.Group.Manager.WorkerManager.html#restart_worker/3","title":"Elsa.Group.Manager.WorkerManager.restart_worker/3","type":"function","doc":"Restart the specified worker from the manager state. Retrieve the latest recorded offset and pass it to the new worker to pick up where the previous left off if it has been recorded."},{"ref":"Elsa.Group.Manager.WorkerManager.html#start_worker/4","title":"Elsa.Group.Manager.WorkerManager.start_worker/4","type":"function","doc":"Construct an argument payload for instantiating a worker process, generate a topic/partition assignment and instantiate the worker process with both under the dynamic supervisor. Record the manager-relevant information and store in the manager state map tracking active worker processes."},{"ref":"Elsa.Group.Manager.WorkerManager.html#stop_all_workers/1","title":"Elsa.Group.Manager.WorkerManager.stop_all_workers/1","type":"function","doc":"Iterate over all workers managed by the group manager and issue the unsubscribe call to disengage from the topic/partition and shut down gracefully."},{"ref":"Elsa.Group.Manager.WorkerManager.html#update_offset/4","title":"Elsa.Group.Manager.WorkerManager.update_offset/4","type":"function","doc":"Update the current offset for a given worker with respect to messages consumed from its topic/partition."},{"ref":"Elsa.Group.Manager.WorkerManager.WorkerState.html","title":"Elsa.Group.Manager.WorkerManager.WorkerState","type":"module","doc":"Tracks the running state of the worker process from the perspective of the group manager."},{"ref":"Elsa.Group.Supervisor.html","title":"Elsa.Group.Supervisor","type":"module","doc":"Orchestrates the creation of dynamic supervisor and worker processes for per-topic consumer groups, manager processes for coordinating topic/partition assignment, and a registry for differentiating named processes between consumer groups."},{"ref":"Elsa.Group.Supervisor.html#child_spec/1","title":"Elsa.Group.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Elsa.Group.Supervisor.html#registry/1","title":"Elsa.Group.Supervisor.registry/1","type":"function","doc":"Provide a name-spaced process registry identifier for differentiating processes between consumer groups."},{"ref":"Elsa.Group.Supervisor.html#start_link/1","title":"Elsa.Group.Supervisor.start_link/1","type":"function","doc":""},{"ref":"Elsa.Group.Supervisor.html#stop/1","title":"Elsa.Group.Supervisor.stop/1","type":"function","doc":"Ensures descendant workers have unsubscribed and unlinked from supervision before gracefully terminating the supervisor process and all remaining children."},{"ref":"Elsa.Group.Worker.html","title":"Elsa.Group.Worker","type":"module","doc":"Defines the worker GenServer that is managed by the DynamicSupervisor. Workers are instantiated and assigned to a specific topic/partition and process messages according to the specified message handler module passed in from the manager before calling the manager&#39;s ack function to notify the cluster the messages have been successfully processed."},{"ref":"Elsa.Group.Worker.html#child_spec/1","title":"Elsa.Group.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Elsa.Group.Worker.html#handle_continue/2","title":"Elsa.Group.Worker.handle_continue/2","type":"function","doc":"Invoked to handle continue instructions. It is useful for performing work after initialization or for splitting the work in a callback in multiple steps, updating the process state along the way. Return values are the same as c:handle_cast/2. This callback is optional. If one is not implemented, the server will fail if a continue instruction is used. This callback is only supported on Erlang/OTP 21+. Callback implementation for GenServer.handle_continue/2."},{"ref":"Elsa.Group.Worker.html#init/1","title":"Elsa.Group.Worker.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Elsa.Group.Worker.html#kafka_message_set/1","title":"Elsa.Group.Worker.kafka_message_set/1","type":"macro","doc":""},{"ref":"Elsa.Group.Worker.html#kafka_message_set/2","title":"Elsa.Group.Worker.kafka_message_set/2","type":"macro","doc":""},{"ref":"Elsa.Group.Worker.html#start_link/1","title":"Elsa.Group.Worker.start_link/1","type":"function","doc":"Start the worker process and init the state with the given config."},{"ref":"Elsa.Group.Worker.html#unsubscribe/1","title":"Elsa.Group.Worker.unsubscribe/1","type":"function","doc":"Trigger the worker to gracefully disengage itself from the supervision tree, unsubscribe from the topic and partition and initiate its own stop sequence."},{"ref":"Elsa.Group.Worker.State.html","title":"Elsa.Group.Worker.State","type":"module","doc":"The running state of the worker process."},{"ref":"Elsa.Message.html","title":"Elsa.Message","type":"module","doc":"Defines the structure of a Kafka message provided by the Elsa library and the function to construct the message struct."},{"ref":"Elsa.Message.html#kafka_message/1","title":"Elsa.Message.kafka_message/1","type":"macro","doc":""},{"ref":"Elsa.Message.html#kafka_message/2","title":"Elsa.Message.kafka_message/2","type":"macro","doc":""},{"ref":"Elsa.Message.html#new/2","title":"Elsa.Message.new/2","type":"function","doc":"Constructs a message struct from the imported definition of a kafka_message as defined by the brod library with the addition of the topic and partition the message was read from as well as the optional generation id as defined by the message&#39;s relationship to a consumer group. Generation id defaults to nil in the event the message retrieved outside of the context of a consumer group."},{"ref":"Elsa.Message.html#t:elsa_message/0","title":"Elsa.Message.elsa_message/0","type":"type","doc":""},{"ref":"Elsa.Message.html#t:kafka_message/0","title":"Elsa.Message.kafka_message/0","type":"type","doc":""},{"ref":"Elsa.Producer.html","title":"Elsa.Producer","type":"module","doc":"Defines functions to write messages to topics based on either a list of endpoints or a named client. All produce functions support the following options: An existing named client process to handle the request can be specified by the keyword option name:. If no partition is supplied, the first (zero) partition is chosen. Value may be a single message or a list of messages. If a list of messages is supplied as the value, the key is defaulted to an empty string binary. If message value is a list, it is expected to be a list of key/value tuples. Partition can be specified by the keyword option partition: and an integer corresponding to a specific partition, or the keyword option partitioner: and the atoms :md5 or :random. The atoms correspond to partitioner functions that will uniformely select a random partition from the total available topic partitions or assign an integer based on an md5 hash of the messages."},{"ref":"Elsa.Producer.html#produce/4","title":"Elsa.Producer.produce/4","type":"function","doc":"Write the supplied message(s) to the desired topic/partition via an endpoint list and optional named client as a one-off operation. Following the completion of the operation, the producer is stopped. If no client is supplied, the default named client is chosen."},{"ref":"Elsa.Producer.html#produce_sync/3","title":"Elsa.Producer.produce_sync/3","type":"function","doc":"Write the supplied messages to the desired topic/partition via a named client specified as a keyword option (via the name: key). Messages may be a single message or a list of messages."},{"ref":"Elsa.Producer.html#t:endpoints/0","title":"Elsa.Producer.endpoints/0","type":"type","doc":""},{"ref":"Elsa.Producer.html#t:hostname/0","title":"Elsa.Producer.hostname/0","type":"type","doc":""},{"ref":"Elsa.Producer.html#t:portnum/0","title":"Elsa.Producer.portnum/0","type":"type","doc":""},{"ref":"Elsa.Producer.html#t:topic/0","title":"Elsa.Producer.topic/0","type":"type","doc":""},{"ref":"Elsa.Producer.Partitioner.html","title":"Elsa.Producer.Partitioner","type":"module","doc":"Provides functions for automatically selecting the topic partition to write a message."},{"ref":"Elsa.Producer.Partitioner.html#partition/3","title":"Elsa.Producer.Partitioner.partition/3","type":"function","doc":"Choose a topic partition based on an md5 hash of the supplied value, typically the message content."},{"ref":"Elsa.Producer.Supervisor.html","title":"Elsa.Producer.Supervisor","type":"module","doc":"Define a supervisor to create and manage producer processes for a given topic, one per topic partition. The supervisor will start a client if one is not already started and passed by name as an argument to the supervisor."},{"ref":"Elsa.Producer.Supervisor.html#child_spec/1","title":"Elsa.Producer.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Elsa.Producer.Supervisor.html#start_link/1","title":"Elsa.Producer.Supervisor.start_link/1","type":"function","doc":"Start a named process for handling subsequent produce_sync requests to write messages to a topic. Producer processes are bound to a specific topic."},{"ref":"Elsa.Topic.html","title":"Elsa.Topic","type":"module","doc":"Provides functions for managing and interacting with topics in the Kafka cluster."},{"ref":"Elsa.Topic.html#create/3","title":"Elsa.Topic.create/3","type":"function","doc":"Creates the supplied topic within the cluster. Sets the number of desired partitions and replication factor for the topic based on the optional keyword list. If the optional configs are not specified by the caller, the number of partitions and replicas defaults to 1."},{"ref":"Elsa.Topic.html#delete/2","title":"Elsa.Topic.delete/2","type":"function","doc":"Deletes the supplied topic from the cluster."},{"ref":"Elsa.Topic.html#exists?/2","title":"Elsa.Topic.exists?/2","type":"function","doc":"Confirms or denies the existence of a topic managed by the cluster."},{"ref":"Elsa.Topic.html#kpro_rsp/1","title":"Elsa.Topic.kpro_rsp/1","type":"macro","doc":""},{"ref":"Elsa.Topic.html#kpro_rsp/2","title":"Elsa.Topic.kpro_rsp/2","type":"macro","doc":""},{"ref":"Elsa.Topic.html#list/1","title":"Elsa.Topic.list/1","type":"function","doc":"Returns a list of all topics managed by the cluster as tuple of topic name and number of partitions."},{"ref":"Elsa.Util.html","title":"Elsa.Util","type":"module","doc":"Provides functions for simplifying first-class interactions (consuming and producing) such as connecting to a cluster and establishing a persistent client process for interacting with a cluster."},{"ref":"Elsa.Util.html#chunk_by_byte_size/3","title":"Elsa.Util.chunk_by_byte_size/3","type":"function","doc":"Process messages into chunks of size up to the size specified by the calling function in bytes, and determined by the function argument. If no chunk size is specified the default maximum size a chunk will be is approximately 1 megabyte. If no sizing function is provided to construct the appropriately sized chunks, the internal function based on Kernel.byte_size/1 is used."},{"ref":"Elsa.Util.html#client?/1","title":"Elsa.Util.client?/1","type":"function","doc":"Determines if client pid is alive"},{"ref":"Elsa.Util.html#get_api_version/2","title":"Elsa.Util.get_api_version/2","type":"function","doc":"Retrieve the api version of the desired operation supported by the connected cluster."},{"ref":"Elsa.Util.html#partition_count/2","title":"Elsa.Util.partition_count/2","type":"function","doc":"Return the number of partitions for a given topic. Bypasses the need for a persistent client for lighter weight interactions from one-off calls."},{"ref":"Elsa.Util.html#reformat_endpoints/1","title":"Elsa.Util.reformat_endpoints/1","type":"function","doc":"Convert supplied cluster endpoints from common keyword list format to brod-compatible tuple."},{"ref":"Elsa.Util.html#start_client/2","title":"Elsa.Util.start_client/2","type":"function","doc":"Create a named client connection process for managing interactions with the connected cluster."},{"ref":"Elsa.Util.html#with_connection/3","title":"Elsa.Util.with_connection/3","type":"function","doc":"Wrap establishing a connection to a cluster for performing an operation."}]